unit qrcb_des;

{$I versions.inc}

interface

uses qrcb_run, graphics, classes, DB, DBTables, quickrpt, BdeConst,

{$IFDEF DELPHI_6_OR_HIGHER}
DesignIntf, DesignEditors, VCLEditors,  RTLConsts;
{$ELSE}
dsgnintf;
{$ENDIF}

type
    {Object Inspector - generic editor for data field names}
    TcFieldsEditor = class(TStringProperty)
  public
     function GetAttributes: TPropertyAttributes; override;
     procedure GetValues(proc: TGetStrProc); override;
  end;

procedure Register;

implementation

function TcFieldsEditor.GetAttributes: TPropertyAttributes;
begin
  {Tell Object Inspector what to expect...}
  Result := [paAutoUpdate, paValueList, paReadOnly, paSortList];
end;

procedure TcFieldsEditor.GetValues(proc: TGetStrProc);
var
  ThisComponent: TQRDbCheckBox;
  Counter: Integer;
begin
  {Provide list of fields to Object Inspector...}
  ThisComponent := TQRDbCheckBox(GetComponent(0));
  with ThisComponent do
    try
      if DataSet <> nil then
	{List every field in the selected DataSet}
	for Counter := 0 to DataSet.FieldCount-1 do
	  if (DataSet.Fields[Counter].DataType
              in [ftBoolean, ftSmallInt, ftLargeInt, ftWord, ftInteger]) then
	    proc(DataSet.Fields[Counter].FieldName);
    except
      {Raise exception}
      DatabaseError(SDatabaseNameMissing);
    end;
end;

procedure Register;
begin
  RegisterComponents('QReport', [TQRCheckBox, TQRDbCheckBox]);
  RegisterPropertyEditor(TypeInfo(String), TQRDbCheckBox,
			 'DataField', TcFieldsEditor);
end;

end.
